/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! COPYRIGHT    (c)  2008, CAHA
! IDENT        Mosaic_cubes.c
! LANGUAGE     C
! AUTHOR       S.F.Sanchez
! KEYWORDS     
! PURPOSE      Mosaic Cubes
! COMMENT      No GROUP information included. No header data properly copied
! VERSION      0.1  2002-Dec-17 : Creation, SF.
------------------------------------------------------------------------------*/
#include "stats.h"
#include <stdlib.h>


#include <stdio.h> //For Standard I/O
#include <ctype.h> //For Type check
#include <string.h> //For String manipulation
#include <math.h> //For Math functions
#include <data_io.h> //For Lyon I/O data

#include <cpgplot.h> // PGPLOT
#include "my_math.h"

#include <IFU_io.h>

#include "stats.h"

#define MAX_MOSAICS 30


main(int argc, char **argv)
{

  FILE *config_id;  
  char config[80];
  char fitsfiles[MAX_MOSAICS][80];
  float dx[MAX_MOSAICS],dy[MAX_MOSAICS];
  float dxmin,dxmax,dymin,dymax;
  int i,j,k,n,n_fits;
  float tmp_f;
  char input_filename[80];
  char output_filename[80];
  double crval[3];
  double cdelt[3];
  IMAGE3D in_cube,out_cube;
  float *out_array;
  long npix;
  int nx_start,ny_start;
  int ii,jj,kk,j_file;
  char **argval, **arglabel;
  long npix_out[3];

  float x0,y0;
  int npoly_x,npoly_y;
  int n_start,n_end;
  float aperture;
  float scale;
  float delta_x,delta_y;
  float *x_c,*y_c;
  float *x,*y,*point;
  float *x_out,*y_out;
  int kmed;
  float x1,y1,x_val,y_val,sum;
  int i_min,i_max,j_min,j_max;
  int nx,ny,nz;
  int NX,NY,NZ;
  float val;
  float min,max;
  float *id;
  float *coeff;
  int nx_0,ny_0;
  int I1,I2,J1,J2;
  float Y1,Y2,Y3,Y4;
  float DX,DY;
  float t,u;
  float VAL;
  float xx,yy;
  float x_med,x_sig,y_med,y_sig;
  int nsigma;
  int smooth;

  if (argc<7) {
      printf("USE: DAR_det_cube input_cube.fits X Y NP_X NP_Y output_cube [N_START] [N_END] [Aperture] [SCALE] [DELTA_X DELTA_Y] [SMOOTH=0/1]\n");
      return(0);
  }
/*
 * Reading the input parameters
 */
   set_user_dataformat();
  strcpy(input_filename,argv[1]);
  x0=atof(argv[3]);
  y0=atof(argv[2]);
  npoly_x=atoi(argv[4]);
  npoly_y=atoi(argv[5]);  


  strcpy(output_filename,argv[6]);

//  printf("ARGC=%f\n",argc);

  n_start=0;
  n_end=0;
  if (argc==9) {
      n_start=atoi(argv[7]);
      n_end=atoi(argv[8]);
  }
  aperture=5.0;
  if (argc==10) {
      n_start=atoi(argv[7]);
      n_end=atoi(argv[8]);
      aperture=atof(argv[9]);
  }
  scale=1;
  if (argc==11) {
      n_start=atoi(argv[7]);
      n_end=atoi(argv[8]);
      aperture=atof(argv[9]);
      scale=atof(argv[10]);
  }
  delta_x=0;
  delta_y=0;
  if (argc==13) {
      n_start=atoi(argv[7]);
      n_end=atoi(argv[8]);
      aperture=atof(argv[9]);
      scale=atof(argv[10]);
      delta_x=atof(argv[11]);
      delta_y=atof(argv[12]);

  }
  smooth=0;
  if (argc==14) {
      n_start=atoi(argv[7]);
      n_end=atoi(argv[8]);
      aperture=atof(argv[9]);
      scale=atof(argv[10]);
      delta_x=atof(argv[11]);
      delta_y=atof(argv[12]);
      smooth=atoi(argv[8]);
  }
//  printf("ARGC=%d '%s' %4.2f %4.2f\n",argc,input_filename,x0,y0);
//  printf("ARGC=%d '%s' %f ('%s') %f %d %d '%s' %d %d %d %f %f %f\n",argc,input_filename,x0,argv[2],y0,npoly_x,npoly_y,output_filename,n_start,n_end,aperture,scale,delta_x,delta_y);
//  fflush(stdout);


  open_cube(&in_cube,input_filename,"I");
  if (argc<9) {
      n_start=0;
      n_end=in_cube.nz;
  }
  nx=in_cube.nx;
  ny=in_cube.ny;
  nz=in_cube.nz;


//  init_session(argv,argc,&arglabel,&argval);


  if(!RD_desc(&in_cube,"CRVAL1",DOUBLE,1,&crval[0])) {
      crval[0]=1;
  } 
  if(!RD_desc(&in_cube,"CRVAL2",DOUBLE,1,&crval[1])) {
      crval[1]=1;
  } 
  if(!RD_desc(&in_cube,"CRVAL3",DOUBLE,1,&crval[2])) {
      crval[2]=1;
  } 
  if(!RD_desc(&in_cube,"CDELT1",DOUBLE,1,&cdelt[0])) {
      cdelt[0]=1;
  }

  if(!RD_desc(&in_cube,"CDELT2",DOUBLE,1,&cdelt[1])) {
      cdelt[1]=1;
  } 
  if(!RD_desc(&in_cube,"CDELT3",DOUBLE,1,&cdelt[2])) {
      cdelt[2]=1;
  } 


  cdelt[0]=cdelt[0]/scale;
  cdelt[1]=cdelt[1]/scale;

  npix_out[0]=floor(in_cube.nx*scale);
  npix_out[1]=floor(in_cube.ny*scale);
  npix_out[2]=in_cube.nz;
  nx_0=npix_out[0];
  ny_0=npix_out[1];
  

  x_c = (float *)malloc((in_cube.nz)*sizeof(float));  	
  y_c = (float *)malloc((in_cube.nz)*sizeof(float));  	
  x_out = (float *)malloc((in_cube.nz)*sizeof(float));  	
  y_out = (float *)malloc((in_cube.nz)*sizeof(float));  	
  id = (float *)malloc((in_cube.nz)*sizeof(float));  	


  
/*
 * We first determine the DAR correction
 */

  x1=x0;
  y1=y0;
//  printf("ARGC=%d '%s' %f ('%s') %f %d %d '%s' %d %d %d %f %f %f %f %f\n",argc,input_filename,x0,argv[2],y0,npoly_x,npoly_y,output_filename,n_start,n_end,aperture,scale,delta_x,delta_y,x1,y1);
  kmed=floor(in_cube.nz/2);
  for (k=kmed;k<in_cube.nz;k++) {
      if (k==kmed) {
	  x1=x0;
	  y1=y0;
      } else {
	  if (fabs(x_val-x1)<0.5) {
	      x1=x_val;
	  }
	  if (fabs(y_val-y1)<0.5) {
	      y1=y_val;
	  }
      }
      i_min=floor(x1-aperture);
      i_max=floor(x1+aperture);
      j_min=floor(y1-aperture);
      j_max=floor(y1+aperture);

      if (j_min<0) {
	  j_min=0;
      }
      if (j_max<0) {
	  j_max=0;
      }
      if (j_max>=ny) {
	  j_max=ny-1;
      }
      if (j_min>=ny) {
	  j_min=ny-1;
      }
      if (i_min<0) {
	  i_min=0;
      }
      if (i_max<0) {
	  i_max=0;
      }
      if (i_max>=nx) {
	i_max=nx-1;
      }
      if (i_min>=nx) {
	  i_min=nx-1;
      } 

      //     printf(" [%d:%d,%d:%d]\n",i_min,i_max,j_min,j_max);
      //getc(stdin);

      x_val=0;
      y_val=0;
      sum=0;
      for (i=i_min;i<i_max+1;i++) {
	  for (j=j_min;j<j_max+1;j++) {
	      val=(float)RD_cube(&in_cube,j,i,k);
	      x_val=x_val+i*val;
	      y_val=y_val+j*val;
	      sum=sum+val;
//	      printf("%d %d %f %f %f\n",i_min,i_max,j_min,j_max);
//	      getc(stdin);
	  }
      }
       if (sum>0) {
	x_val=x_val/sum;
	y_val=y_val/sum;
    }
      x_c[k]=x_val;
      y_c[k]=y_val;
      id[k]=(float)k;
//      printf("%f %f %f [%d:%d,%d:%d]\n",id[k],x_val,y_val,i_min,i_max,j_min,j_max);
  }

  kmed=floor(in_cube.nz/2);
  for (k=kmed;k>-1;k--) {
      if (k==kmed) {
	  x1=x0;
	  y1=y0;
      } else {
	  if (fabs(x_val-x1)<0.5) {
	      x1=x_val;
	  }
	  if (fabs(y_val-y1)<0.5) {
	      y1=y_val;
	  }
      }
      i_min=floor(x1-aperture);
      i_max=floor(x1+aperture);
      j_min=floor(y1-aperture);
      j_max=floor(y1+aperture);

      if (j_min<0) {
	  j_min=0;
      }
      if (j_max<0) {
	  j_max=0;
      }
      if (j_max>=ny) {
	  j_max=ny-1;
      }
      if (j_min>=ny) {
	  j_min=ny-1;
      }
      if (i_min<0) {
	  i_min=0;
      }
      if (i_max<0) {
	  i_max=0;
      }
      if (i_max>=nx) {
	i_max=nx-1;
      }
      if (i_min>=nx) {
	  i_min=nx-1;
      } 
      x_val=0;
      y_val=0;
      sum=0;
      for (i=i_min;i<i_max+1;i++) {
	  for (j=j_min;j<j_max+1;j++) {
	      val=(float)RD_cube(&in_cube,j,i,k);
	      x_val=x_val+i*val;
	      y_val=y_val+j*val;
	      sum=sum+val;
	  }
      }
      if (sum>0) {
	x_val=x_val/sum;
	y_val=y_val/sum;
      }
      x_c[k]=x_val;
      y_c[k]=y_val;      
      id[k]=(float)k;
  }


/*
 * We mask the wrong values 
 */
  NZ=n_end-n_start+1;
  x = (float *)malloc((NZ)*sizeof(float));  	
  y = (float *)malloc((NZ)*sizeof(float));  	
  point = (float *)malloc((NZ)*sizeof(float));  

  NZ=0;
  for (k=n_start;k<n_end;k++) {
//      if ((fabs(x_c[k]-x_med)<3*x_sig)&&(fabs(y_c[k]-y_med)<3*y_sig)) {
      point[NZ]=k;      
      y[NZ]=x_c[k];
      x[NZ]=y_c[k];
//      printf("%f,%f\n",x_c[k],y_c[k]);
      NZ++;
//      }
  }

  x_med=median(x,NZ);
  x_sig=sigma(x,NZ,x_med);
  y_med=median(y,NZ);
  y_sig=sigma(y,NZ,y_med);

  if (smooth==1) {
      NZ=0;
      nsigma=5;
      
      do {
	  NZ=0;
	  for (k=n_start;k<n_end;k++) {
	      if ((fabs(x_c[k]-x_med)<nsigma*x_sig)&&(fabs(y_c[k]-y_med)<nsigma*y_sig)) {
		  point[NZ]=k;      
		  y[NZ]=x_c[k];
		  x[NZ]=y_c[k];
		  NZ++;
	      }
	  }
	  nsigma++;
      } while (NZ<0.4*nz);
  }




  if (i_min<j_min) {
      min=i_min;
  } else {
      min=j_min;
  }

  if (i_max>j_max) {
      max=i_max;
  } else {
      max=j_max;
  }


  coeff = (float *)malloc((npoly_x)*sizeof(float));  	
  polyfit(point,x,NZ,coeff,npoly_x);
  for (k=0;k<nz;k++) {
      x_out[k]=0;
      for (j=0;j<npoly_x;j++) {
	  x_out[k]=x_out[k]+coeff[j]*pow(id[k],j);
      }
      if (min>x_out[k]) {
	  min=x_out[k];
      }
      if (max<x_out[k]) {
	  max=x_out[k];
      }
  }
  free(coeff);

  coeff = (float *)malloc((npoly_y)*sizeof(float));  	
  polyfit(point,y,NZ,coeff,npoly_y);
  for (k=0;k<nz;k++) {
      y_out[k]=0;
      for (j=0;j<npoly_y;j++) {
	  y_out[k]=y_out[k]+coeff[j]*pow(id[k],j);
      }
      if (min>y_out[k]) {
	  min=y_out[k];
      }
      if (max<y_out[k]) {
	  max=y_out[k];
      }

  }
  free(coeff);

/*
*/
  max=max+0.5;
  min=min-0.5;
  
  cpgopen("/xs");
  cpgsfs(1.2);
  cpgscf(2);
  cpgslw(2); 
  cpgsch(1.6); 
  cpgenv(0,nz,min,max,0,0);
  cpgsch(1.6); 
  cpgsch(2.2); 
  cpgsci(2);
  cpgpt(NZ,point,x,3);    
  cpgsci(4);
  cpgpt(NZ,point,y,3);    
  cpgsci(1);
  cpgline(nz,id,x_out);
  cpgline(nz,id,y_out);
  cpgclos();
  cpgend;

  create_cube(&out_cube,output_filename,npix_out,crval,cdelt,FLOAT,"DAR_COR Cube",NULL);
  for (k=0;k<nz;k++) {
      for (i=0;i<nx_0;i++) {
	  for (j=0;j<ny_0;j++) {
	      DX=(x_out[k]-y0);
	      DY=(y_out[k]-x0);
	      xx=i/scale+DX-delta_x;
	      yy=j/scale+DY-delta_y;
	      I1=floor(xx);
	      I2=floor(xx+1);
	      J1=floor(yy);
	      J2=floor(yy+1);
	      if (I1<0) {
		  I1=0;
	      }
	      if (I2<0) {
		  I2=0;
	      }
	      if (I2>nx-1) {
		  I2=nx-1;
	      }
	      if (I1>nx-1) {
		  I1=nx-1;
	      }
	      if (J1<0) {
		  J1=0;
	      }
	      if (J2<0) {
		  J2=0;
	      }
	      if (J1>ny-1) {
		  J1=ny-1;
	      }
	      if (J2>ny-1) {
		  J2=ny-1;
	      }
	      Y1=RD_cube(&in_cube,I1,J1,k);
	      Y2=RD_cube(&in_cube,I2,J1,k);
	      Y3=RD_cube(&in_cube,I2,J2,k);
	      Y4=RD_cube(&in_cube,I1,J2,k);
	      t=xx-I1;
	      u=yy-J1;
	      VAL=((1-t)*(1-u))*Y1+(t*(1-u))*Y2+(t*u)*Y3+((1-t)*u)*Y4;
//	      printf("%f,%f %f,%f %f-%f,%f-%f [%d:%d,%d:%d] %f,%f,%f,%f\n",xx,yy,DX,DY,x_out[k],x0,y_out[k],y0,I1,I2,J1,J2,Y1,Y2,Y3,Y4);
	      VAL=VAL/(scale*scale);
	      WR_cube(&out_cube,i,j,k,VAL);
	  }
      }
//      printf("%f,%f %f,%f %f-%f,%f-%f\n",xx,yy,DX,DY,x_out[k],x0,y_out[k],y0);

  }   

      close_cube(&out_cube); 
      close_cube(&in_cube); 
      

//
      


      
      exit_session(0);
      return(0);	
}



