/*
! COPYRIGHT    (c)  2005 CAHA, Spain
! IDENT        imarith.c
! LANGUAGE     C
! AUTHOR       S.F.Sanchez
! KEYWORDS     
! PURPOSE      C version of disp_cor.pl
! COMMENT      
! VERSION      0.1  22.11.05 : Creation, SF.
------------------------------------------------------------------------------*/

#include <IFU_io.h>

#include "stats.h"
#include <stdlib.h>


#include <stdio.h> //For Standard I/O
#include <ctype.h> //For Type check
#include <string.h> //For String manipulation
#include <math.h> //For Math functions
#include <data_io.h> //For Lyon I/O data

#include <cpgplot.h> // PGPLOT
#include "my_math.h"
#include "gl_lsq.h"

main(int argc, char *ARGV[])
{
  FILE *FH;
  char infile[80],out_file[80],disp_file[80];
  float crval,cdelt;
  int aperture,ny_cen,ny_width,npoly,plot;
  float *spec,*cut,*w;
  float fmin,fmax;

  long npix[2];
  double start[2];
  double step[2]; 
  IMAGE2D image,disp_cor;
  int j_min,j_max;
  int i,j,k,nx,ny;
  float mean_flux,sigma_flux,temp;
  float xp[1000],yp[1000],wp[1000],mp[1000],sxp[1000];
  float xt[1000],yt[1000],wt[1000],mt[1000],sxt[1000];
  float x,y,x_cen,x_delta,y_cen,y_delta;
  int a,b,c;
  float fa,fb,fc,den,x_peak;
  float borders[4],borders_ini[4];
  float xs[1],ys[1],xx[2],yy[2];
  char file[80];
  char LOOP,QUIT,command,car;
  int flag;
  int np=0;
  int i_min,i_max,i_peak;
  float maximun;
  char swp[10];
  int nmax,n,kk;
  float rms;
  float *coeff;
  float *x_new,*x_old;
  float *a_i_new,*a_i_old;
  int i_old_max;
  float x_max;
  float wave_n;
  int n_cut;

  float *out_array,*wave,*wave_new,*out_spec;//,*in_array;

  if (argc<10) {
    printf("USE: disp_cor EXTRACTED.fits CRVAL CDELT APERTURE NY_SPECTRA WITDH NPOLY OUTPUT.fits DISPERSION.txt plot [NMAX] [file.id]\n");
    return(0);
  }
  set_user_dataformat();
  strcpy(infile,ARGV[1]);    
  crval=atof(ARGV[2]);
  cdelt=atof(ARGV[3]);
  aperture=atoi(ARGV[4]);
  ny_cen=atoi(ARGV[5]);
  ny_width=atoi(ARGV[6]);
  npoly=atoi(ARGV[7]);
  strcpy(out_file,ARGV[8]);    
  strcpy(disp_file,ARGV[9]);    
//  plot=atoi(ARGV[10]);
  plot=1;
  nmax=0;
  if (argc==12) {
    nmax=atoi(ARGV[11]);
  }
  
 command=' ';
 if (argc==13) {
     nmax=atoi(ARGV[11]);
     strcpy(file,ARGV[12]);
     plot=0;
     command='F';
 }

  open_frame(&image,infile,"I");
  npix[0]=image.nx;
  npix[1]=image.ny;
  nx=image.nx;
  ny=image.ny;
  start[0]=crval;
  start[1]=0.0;
  step[0]=cdelt;
  step[1]=1.0;  
  fmin=1e12;
  fmax=-1e12;
  spec = (float *)malloc((image.nx)*sizeof(float));  	
  w = (float *)malloc((image.nx)*sizeof(float));  	

  /*
    We construct the checking spectrum
  */
  j_min=ny_cen-ny_width;
  j_max=ny_cen+ny_width;
  if (j_min<0) {
    j_min=0;
  }
  if (j_max>ny) {
    j_max=ny;
  }
  for (i=0;i<nx;i++) {
    cut = (float *)malloc((j_max-j_min+1)*sizeof(float));  	
    k=0;
    for (j=j_min;j<j_max;j++) {
      cut[k]=RD_frame(&image,i,j);
      k++;
    }
    w[i]=i*1.0;
    spec[i]=fmean(cut,k);
    if (fmin>spec[i]) {
      fmin=spec[i];
    }
    if (fmax<spec[i]) {
      fmax=spec[i];
    }
    free(cut);
  }

    borders_ini[0]=0.0;
    borders_ini[1]=1.0*image.nx;
    borders_ini[2]=fmin;
    borders_ini[3]=fmax;
    borders[0]=0.0;
    borders[1]=1.0*image.nx;
    borders[2]=fmin;
    borders[3]=fmax;
// #
//  Main Loop to select the features.
// 
    do {
    QUIT='N';
    LOOP='Q';
    printf("a => Unzoom\n");
    printf("x => X-Zoom\n");
    printf("y => Y-Zoom\n");
    printf("m => Mark a peak\n");
    printf("d => delete a peak\n");
    printf("r => Move right\n");
    printf("l => Move left\n");
    printf("R => Load a file\n");
    printf("W => Save a file\n");
    printf("F => Load a file and recenter the peaks\n");
    printf("Q => Quit\n");    
    cpgopen("/xs");
    cpgask(0);    
    while(QUIT!='Y') {
	cpgsfs(1.2);
	cpgscf(2);             //  Set character font
	cpgslw(2);             //  Set line width
	cpgsch(1.2);           //  Set character height
	cpgenv(borders[0],borders[1],borders[2],borders[3],0,1);
	cpgsci(1);
	cpgsci(7);
	cpgline(image.nx,w,spec);
	cpgsch(2);
	cpgsci(5);
	for (i=0;i<np;i++) {
	    if (mp[i]==1) {
		xs[0]=xp[i];
		ys[0]=yp[i];
		cpgpt(1,xs,ys,2);
		sprintf(swp,"%f6.1",wp[i]);
		cpgsch(0.8);
		cpgptxt(xp[i],1.5*yp[i],0,0.5,swp);
		cpgsch(2);
	    }
	}
	cpgsch(1.2);
	cpgsci(1);
//	command=' ';
//	if (command!='F') {
//	    command=' ';
//	}


	    if (command=='F') {
		QUIT='Y';
//		printf("Refit Identification file?");
//		scanf("%s",file);
		printf("Opening file: %s\n",file);
		np=0;
		if ((FH=fopen(file,"r"))==NULL) {
		    printf("Error opening file: %s\n",file);
		    return(-1);
		} else {    
		    while((car=getc(FH))!=EOF) {
			flag=1;
			if (car=='\n')
			{
			    np+=1;
			    flag+=1;
			}
		    }
		    if (flag==1) {
			np=np+1;
		    } else {
			np=np;
		    }
		    printf("NP=%d\n",np);
		    rewind(FH);
		    for (j=0;j<np;j++) {
			fscanf(FH, "%f", &xt[j]);
			fscanf(FH, "%f", &wt[j]);
		    }

/**************************************
// Now we look for the nearest maximun
*************************************/
		    for (j=0;j<np;j++) {
			x=xt[j];
			i_min=(int)(x)-aperture;
			i_max=(int)(x)+aperture;
			i_peak=(int)(x);
			maximun=-1e12;
			for (i=i_min;i<i_max;i++) {
			    if ((spec[i]>maximun)&&(spec[i]>spec[i-1])&&(spec[i-1]>spec[i-2])&&(spec[i]>spec[i+1])&&(spec[i+1]>spec[i+2])) {
				i_peak=i;
				maximun=spec[i];
			    }
			}
			a=i_peak-1;
			b=i_peak;
			c=i_peak+1;
			fa=-spec[a];
			fb=-spec[b];
			fc=-spec[c];
			den=(fc-2*fb+fa);
			if (den!=0) {
			    x_peak=c-(b-a)*((fc-fb)/den+0.5);
			} else {
			    x_peak=i_peak;
			}
			xp[j]=x_peak;
			yp[j]=spec[i_peak];
			mp[j]=1;
			wp[j]=wt[j];
		    }
		    
		    for (i=0;i<np;i++) {
			for (j=(i+1);j<np;j++) {
			    if (xp[j]<xp[i]) {
				temp=xp[j];
				xp[j]=xp[i];
				xp[i]=temp;
				temp=wp[j];
				wp[j]=wp[i];
				wp[i]=temp;
			    }    
			}
		    }
		    for (j=0;j<np;j++) {
//			printf("%d %f %f\n",j,xp[j],wp[j]);
			mp[j]=1;
			yp[j]=spec[(int)xp[j]];			
		    }
		}
		fclose(FH);
		n=np;
		printf("%d (%d) lines found\n",np,n);
		command='F';
		plot=0;
//		command='X';
	    }
	


	    if (command!='F') {
		command=' ';
	    } else {
		command='X';
	    }
	    
	    
	    
	while (command!='X') {
	    cpgband(7,0,50,50,&x,&y,&command);
	    if (command=='x') {
		x_cen=0.5*(borders[1]-borders[0])+borders[0];
		x_delta=0.5*(borders[1]-borders[0]);
		x_cen=x;
		x_delta=0.75*x_delta;
		borders[0]=x_cen-x_delta;
		borders[1]=x_cen+x_delta;
		command='X';
	    }
	    if (command=='y') {
		y_cen=0.5*(borders[3]-borders[2])+borders[2];
		y_delta=0.5*(borders[3]-borders[2]);
		y_cen=y;
		y_delta=0.75*y_delta;
		borders[2]=y_cen-y_delta;
		borders[3]=y_cen+y_delta;
		command='X';
	    }
	    if (command=='r') {
		x_cen=0.5*(borders[1]-borders[0])+borders[0];
		x_delta=0.5*(borders[1]-borders[0]);
		x_cen=x_cen+0.25*x_delta;
		borders[0]=x_cen-x_delta;
		borders[1]=x_cen+x_delta;
		command='X';
	    }
	    if (command=='l') {
		x_cen=0.5*(borders[1]-borders[0])+borders[0];
		x_delta=0.5*(borders[1]-borders[0]);
		x_cen=x_cen-0.25*x_delta;
		borders[0]=x_cen-x_delta;
		borders[1]=x_cen+x_delta;
		command='X';
	    }
	    if (command=='a') {
		for (i=0;i<4;i++) {
		    borders[i]=borders_ini[i];
		}
		command='X';
	    }
	    if (command=='q') {
		command='X';
		QUIT='Y';
	    }

//	    printf("\n *** \n command=%c\n",command);	    

	    if (command=='R') {
		printf("Identification file?");
		scanf("%s",file);
		printf("Opening file: %s\n",file);
		np=0;
		if ((FH=fopen(file,"r"))==NULL) {
		    printf("Error opening file: %s\n",file);
		    return(-1);
		} else {    
		    while((car=getc(FH))!=EOF) {
			flag=1;
			if (car=='\n')
			{
			    np+=1;
			    flag+=1;
			}
		    }
		    if (flag==1) {
			np=np+1;
		    } else {
			np=np;
		    }
		    printf("NP=%d\n",np);
		    rewind(FH);
		    for (j=0;j<np;j++) {
			fscanf(FH, "%f", &xp[j]);
			fscanf(FH, "%f", &wp[j]);
		    }

		    for (i=0;i<np;i++) {
			for (j=(i+1);j<np;j++) {
			    if (xp[j]<xp[i]) {
				temp=xp[j];
				xp[j]=xp[i];
				xp[i]=temp;
				temp=wp[j];
				wp[j]=wp[i];
				wp[i]=temp;
			    }    
			}
		    }
		    for (j=0;j<np;j++) {
//			printf("%d %f %f\n",j,xp[j],wp[j]);
			mp[j]=1;
			yp[j]=spec[(int)xp[j]];			
		    }
		}
		fclose(FH);
		n=np;
		printf("%d (%d) lines found\n",np,n);
		command='X';
	    }

	    if (command=='F') {
//		QUIT='Y';
		printf("Refit Identification file?");
		scanf("%s",file);
		printf("Opening file: %s\n",file);
		np=0;
		if ((FH=fopen(file,"r"))==NULL) {
		    printf("Error opening file: %s\n",file);
		    return(-1);
		} else {    
		    while((car=getc(FH))!=EOF) {
			flag=1;
			if (car=='\n')
			{
			    np+=1;
			    flag+=1;
			}
		    }
		    if (flag==1) {
			np=np+1;
		    } else {
			np=np;
		    }
		    printf("NP=%d\n",np);
		    rewind(FH);
		    for (j=0;j<np;j++) {
			fscanf(FH, "%f", &xt[j]);
			fscanf(FH, "%f", &wt[j]);
		    }

/**************************************
// Now we look for the nearest maximun
*************************************/
		    for (j=0;j<np;j++) {
			x=xt[j];
			i_min=(int)(x)-aperture;
			i_max=(int)(x)+aperture;
			i_peak=(int)(x);
			maximun=-1e12;
			for (i=i_min;i<i_max;i++) {
			    if ((spec[i]>maximun)&&(spec[i]>spec[i-1])&&(spec[i-1]>spec[i-2])&&(spec[i]>spec[i+1])&&(spec[i+1]>spec[i+2])) {
				i_peak=i;
				maximun=spec[i];
			    }
			}
			a=i_peak-1;
			b=i_peak;
			c=i_peak+1;
			fa=-spec[a];
			fb=-spec[b];
			fc=-spec[c];
			den=(fc-2*fb+fa);
			if (den!=0) {
			    x_peak=c-(b-a)*((fc-fb)/den+0.5);
			} else {
			    x_peak=i_peak;
			}
			xp[j]=x_peak;
			yp[j]=spec[i_peak];
			mp[j]=1;
			wp[j]=wt[j];
		    }
		    
		    for (i=0;i<np;i++) {
			for (j=(i+1);j<np;j++) {
			    if (xp[j]<xp[i]) {
				temp=xp[j];
				xp[j]=xp[i];
				xp[i]=temp;
				temp=wp[j];
				wp[j]=wp[i];
				wp[i]=temp;
			    }    
			}
		    }
		    for (j=0;j<np;j++) {
//			printf("%d %f %f\n",j,xp[j],wp[j]);
			mp[j]=1;
			yp[j]=spec[(int)xp[j]];			
		    }
		}
		fclose(FH);
		n=np;
		printf("%d (%d) lines found\n",np,n);
		//command='F';
		command='X';
	    }
	    if (command=='W') {
		printf("Saving Identification file?"); 
		scanf("%s",file);
		FH=fopen(file,"w");
		for (j=0;j<np;j++) {
		    if (mp[j]==1) {
		      fprintf(FH,"%f %f\n",xp[j],wp[j]);
		    }
		}
		fclose(FH);
		command='X';
	    }
	    
//	    printf("command=%c [%f,%f]\n",command,x,y);
	    
	    if (command=='m') {
		xs[0]=x;
		ys[0]=spec[(int)floor(x)];
		cpgsci(8);
		cpgpt(1,xs,ys,2);
		cpgsci(1);
		i_min=(int)(x)-aperture;
		i_max=(int)(x)+aperture;
		i_peak=(int)(x);
		maximun=-1e12;
		for (i=i_min;i<i_max;i++) {
		    if ((spec[i]>maximun)&&(spec[i]>spec[i-1])&&(spec[i-1]>spec[i-2])&&(spec[i]>spec[i+1])&&(spec[i+1]>spec[i+2])) {
			i_peak=i;
			maximun=spec[i];
		    }
		}
		a=i_peak-1;
		b=i_peak;
		c=i_peak+1;
		fa=-spec[a];
		fb=-spec[b];
		fc=-spec[c];
		den=(fc-2*fb+fa);
		if (den!=0) {
		    x_peak=c-(b-a)*((fc-fb)/den+0.5);
		} else {
		    x_peak=i_peak;
		}
		xp[np]=x_peak;
		yp[np]=spec[i_peak];
		mp[np]=1;
		printf("Wavelength at %f?",x_peak);
		scanf("%f",&wp[np]);
		np++;
		cpgsch(2);
		cpgsci(5);
		for (i=0;i<np;i++) {
		    xs[0]=xp[i];
		    ys[0]=yp[i];
		    if (mp[i]==1) {
			cpgpt(1,xs,ys,2);
		    }
		}
		cpgsci(1);
		cpgsch(1.2);



		command='X';
	    }
	    if (command=='d') {
		xs[0]=x;
		ys[0]=spec[(int)floor(x)];
		i_min=(int)floor(x)-aperture;
		i_max=(int)floor(x)+aperture;
		i_peak=(int)floor(x);
		printf("%d %d %d\n",i_min,i_max,i_peak);
		for (i=0;i<np;i++) {
		    if (fabs(i_peak-xp[i])<aperture) {
			mp[i]=0;
		    }
		}
		cpgsch(2);
		for (i=0;i<np;i++) {
		    xs[0]=xp[i];
		    ys[0]=yp[i];		    
		    if (mp[i]==1) {
			cpgsci(5);
			cpgpt(1,xs,ys,2);
		    } else {
			cpgsci(2);
			cpgpt(1,xs,ys,22);
		    }
		}
		cpgsci(1);
		cpgsch(1.2);
		command='X';
	    }
	    
	
	}
	    
    }
    cpgclos();
    cpgend();
    


    
    /*
      We determine now the pixels in the new coordinate system:
    */
    n=0;
    for (i=0;i<np;i++) {
      if (mp[i]==1) {
	n++;
      }
    }
    x_new = (float *)malloc((n)*sizeof(float));  	
    x_old = (float *)malloc((n)*sizeof(float));  	
    n=0;
    x_max=0;
    for (i=0;i<np;i++) {
      if (mp[i]==1) {
	x_old[n]=xp[i];	
	x_new[n]=(wp[i]-crval)/cdelt;
	//printf("%d %f %f %f\n",i,x_old[n],x_new[n],wp[i]);
	if (x_max<x_new[n]) {
	  x_max=x_new[n]+10;
	}
	n++;
      }
    }
    //    printf("nmax=%d",nmax);
//    if (nmax==0) {
    n_cut=(int)x_new[n-1]+(int)floor((image.nx-x_old[n-1])*x_new[n-1]/x_old[n-1]);
//    }
    //    printf("n_cut=%d",n_cut);
    //    printf()

    a_i_new = (float *)malloc((n_cut)*sizeof(float));  	
    a_i_old = (float *)malloc((n_cut)*sizeof(float));  

    if (npoly==0) {      
      //      	for (i=0;i<image.nx;i++) {
      //	  a_i_old[i]=i;
      //	}
	for (i=0;i<n_cut;i++) {
	  a_i_new[i]=i;
	}
	spline1(x_new,x_old,n,a_i_new,a_i_old,n_cut);
	i_old_max=a_i_old[n_cut];
	printf("N_MAX=%i\n",n_cut);
	rms=0;
	for (i=0;i<n;i++) {
	  rms=rms+pow(fabs(a_i_old[(int)round(x_new[i])]-x_old[i]),2);
	}
	rms=pow((rms/n),0.5);
	printf("RMS=%f\n",rms);
    } else {
      if (npoly>0) {
	coeff = (float *)malloc((npoly)*sizeof(float));  	
	polyfit(x_new,x_old,n,coeff,npoly);
	for (i=0;i<n_cut;i++) {
	  a_i_new[i]=i;
	  a_i_old[i]=0;
	  for (kk=0;kk<npoly;kk++) {	    
	    a_i_old[i]=a_i_old[i]+coeff[kk]*pow(i,kk);
	  }	    
	}	
	free(coeff);
	i_old_max=a_i_old[n_cut];
	printf("N_MAX=%i\n",n_cut);
	rms=0;
	for (i=0;i<n;i++) {
//	    printf("RMS=%f,%d %f %f\n",rms,n,a_i_old[(int)round(x_new[i])],x_old[i]);
	  rms=rms+pow(fabs(a_i_old[(int)round(x_new[i])]-x_old[i]),2);
//	  rms=rms+pow(fabs(a_i_old[(int)round(x_new[i])]-x_old[i]),2);
	}
	rms=pow((rms/n),0.5);
	printf("RMS=%f\n",rms);	
      } else {
	coeff = (float *)malloc((fabs(npoly))*sizeof(float));  	
	chebyshevfit(x_new,x_old,n,coeff,abs(npoly));
	for (i=0;i<n_cut;i++) {
	  a_i_new[i]=i;
	  a_i_old[i]=0;
	  for (kk=0;kk<fabs(npoly);kk++) {	    
	    a_i_old[i]=a_i_old[i]+coeff[kk]*chebyshev(i,kk);
	  }	    
	}	
	free(coeff);
	i_old_max=a_i_old[n_cut];
	printf("N_MAX=%i\n",n_cut);
	rms=0;
	for (i=0;i<n;i++) {
	  rms=rms+pow(fabs(a_i_old[(int)round(x_new[i])]-x_old[i]),2);
//	  rms=rms+pow(fabs(a_i_old[(int)round(x_new[i])]-x_old[i]),2);
	}
	rms=pow((rms/n),0.5);
	printf("RMS=%f\n",rms);	

      }
    }

//    printf("n_cut=%d",n_cut);

if (plot==1) {
    cpgopen("/xs");
    cpgsfs(1.2);
    cpgscf(2);            // # Set character font
    cpgslw(2);            // # Set line width
    cpgsch(1.2);          // //  Set character height
    cpgenv(0,nx,0,1.0*n_cut,0,0);
    cpglab("X old","X new","Dispersion solution");
    cpgsci(1);
    cpgpt(n,x_old,x_new,2);
    cpgsci(2);
    cpgline(n_cut,a_i_old,a_i_new);
    cpgsch(0.7);
    /*
    for (i=0;i<n;i++) {
	pgsci(5);
	sprintf(swp,"%f6.1",rms_now[i]);
	cpgsch(1.1);
	pgptxt(x_old[i],x_new[i],0,0.5,swp);
	cpgsch(2);
    }
    */
    cpgsci(1);
    cpgclos();
    cpgend();
    printf("Press 'Q' to Quit or any other key to repeat");
    scanf("%c",&command);
    if (command=='N') {
      printf("New Order of the Polynomical function?");
      scanf("%i",&npoly);
      QUIT='N';
      command=' ';
    }
    if (command=='Q') {
      LOOP='E';
    } else {
      QUIT='N';
      command=' ';
    }
} else {
    LOOP='E';
}
    } while(LOOP=='Q');

    //  We save the dispersion correction
    if (nmax>n_cut) {
	nmax=n_cut;
    }
    if (nmax==0) {
	nmax=n_cut;
    }

    printf("Writting the dispersion solution at '%s'\n",disp_file);
    FH=fopen(disp_file,"w");
    fprintf(FH,"# Dispersion solution\n"); 
//    return;
    for (i=0;i<nmax;i++) {
      wave_n=crval+cdelt*i;
      fprintf(FH,"%d %f %f\n",i,wave_n,a_i_old[i]);

//      printf("%d %f %f\n",i,wave_n,a_i_old[i]);
    }
    fclose(FH);


// 
//  We correct for the new dispersion
// 

    out_array = (float *)malloc((nmax*image.ny)*sizeof(float)); 
    spec = (float *)malloc((image.nx)*sizeof(float));  	
    wave = (float *)malloc((image.nx)*sizeof(float));  	
    wave_new = (float *)malloc((n_cut)*sizeof(float));  	
    out_spec = (float *)malloc((n_cut)*sizeof(float));  	


    for (j=0;j<ny;j++) {
	for (i=0;i<nx;i++) {
	    spec[i]=RD_frame(&image,i,j);
	    wave[i]=1.0*i;
	}	
	spline1(wave,spec,npix[0],a_i_old,out_spec,n_cut);
	fmin=1e12;
	fmax=-1e12;
	for (i=0;i<nmax;i++) {
	    wave_new[i]=crval+cdelt*i;
	    out_array[i+j*nmax]=out_spec[i];
	    if (fmin>out_spec[i]) {
		fmin=out_spec[i];
	    }
	    if (fmax<out_spec[i]) {
		fmax=out_spec[i];
	    }
	}
	
	if (plot==1) {
	    cpgopen("/xs");
	    cpgsfs(1.2);
	    cpgscf(2);             //  Set character font
	    cpgslw(2);             //  Set line width
	    cpgsch(1.2);           //  Set character height
	    cpgenv(crval,crval+cdelt*n_cut,fmin,fmax,0,0);
	    cpglab("Wavelength","Counts","");
	    cpgsci(1);
	    cpgline(n_cut,wave_new,out_spec);
	    cpgclos();
	    cpgend();
	    printf("Press Enter (A=Automatic, no plot)");
	    scanf("%c",&command);
	    if (command=='A') {
		plot=0;
	    }
	}    
    }

   close_frame(&image);

   printf("Writting the %s file\n",out_file);
   npix[0]=nmax;
   create_frame(&disp_cor,out_file,npix,start,step,FLOAT,"EXTRACTED",NULL);
   for (i=0;i<nmax;i++) {
       for (j=0;j<npix[1];j++) {
	   WR_frame(&disp_cor,i,j,out_array[i+j*nmax]);
       }
   }
   close_frame(&disp_cor);    


   return(0);
}

/*







print "Writting the out_file\n";
system("rm out_file");
write_rss(out_file,n_cut,ny,crval,cdelt,\out_array);
print "DONE\n";

exit;

*/
