/*
! COPYRIGHT    (c)  2005 CAHA, Spain
! IDENT        imarith.c
! LANGUAGE     C
! AUTHOR       S.F.Sanchez
! KEYWORDS     
! PURPOSE      C version of disp_cor.pl
! COMMENT      
! VERSION      0.1  22.11.05 : Creation, SF.
------------------------------------------------------------------------------*/

#include <IFU_io.h>

#include "stats.h"
#include <stdlib.h>


#include <stdio.h> //For Standard I/O
#include <ctype.h> //For Type check
#include <string.h> //For String manipulation
#include <math.h> //For Math functions
#include <data_io.h> //For Lyon I/O data

#include <cpgplot.h> // PGPLOT
#include "my_math.h"
#include "gl_lsq.h"

main(int argc, char *ARGV[])
{
  FILE *FH;
  char infile[80],out_file[80],disp_file[80];
  float crval,cdelt;
  int aperture,ny_cen,ny_width,npoly,plot;
  float *spec,*cut,*w;
  float fmin,fmax;

  long npix[2];
  double start[2];
  double step[2]; 
  IMAGE2D image,disp_cor;
  int j_min,j_max;
  int i,j,k,nx,ny;
  float mean_flux,sigma_flux,temp;
  int temp_i;
  float xp[1000],yp[1000],wp[1000],mp[1000],sxp[1000];

  float x,y,x_cen,x_delta,y_cen,y_delta;
  int a,b,c;
  float fa,fb,fc,den,x_peak;
  float borders[4],borders_ini[4];
  float xs[1],ys[1],xx[2],yy[2];
  char file[80];
  char LOOP,QUIT,command,car;
  int flag;
  int np=0;
  int i_min,i_max,i_peak;
  float maximun;
  char swp[10];
  int nmax,n,kk;
  float rms;
  float *coeff;
  float *x_new,*x_old;
  float *a_i_new,*a_i_old;
  int i_old_max;
  float x_max;
  float wave_n;

  float *out_array,*wave,*wave_new,*out_spec;//,*in_array;

  if (argc<6) {
    printf("USE: disp_cor_external EXTRACTED.fits CRVAL CDELT OUTPUT.fits DISPERSION.txt plot\n");
    return(0);
  }
  set_user_dataformat();
  strcpy(infile,ARGV[1]);    
  crval=atof(ARGV[2]);
  cdelt=atof(ARGV[3]);
  strcpy(out_file,ARGV[4]);    
  strcpy(disp_file,ARGV[5]);    
  plot=atoi(ARGV[6]);



/*
 * We read the distorion FITS file
 */

  if ((FH=fopen(disp_file,"r"))==NULL) {
      printf("Error opening file: %s\n",disp_file);
      return(-1);
  } else {    
      while((car=getc(FH))!=EOF) {
	  flag=1;
	  if (car=='\n')
	  {
	      np+=1;
	      flag+=1;
	  }
      }
      if (flag==1) {
	  np=np+1;
      } else {
	  np=np;
      }
      np=np-1;
//      printf("=%d\n",np);
      nmax=np;
      a_i_new = (float *)malloc((nmax)*sizeof(float));  	
      a_i_old = (float *)malloc((nmax)*sizeof(float));  

      rewind(FH);
// We jump one line
	flag=0;
	while(flag==0) {
	    car=getc(FH);
	    if (car=='\n') {
		 flag=1;
	    }
	}

      for (j=0;j<np;j++) {
	  fscanf(FH, "%d", &temp_i);
	  a_i_new[j]=1.0*temp_i;
	  fscanf(FH, "%f", &temp);
	  fscanf(FH, "%f", &temp);
	  a_i_old[j]=temp;
//	  printf("%d %f %f\n",j,a_i_new[j],a_i_old[j]);
	  
      }
  }


/*
 * Reading the in-file
 */
  open_frame(&image,infile,"R");
  npix[0]=image.nx;
  npix[1]=image.ny;
  nx=image.nx;
  ny=image.ny;
  start[0]=crval;
  start[1]=0.0;
  step[0]=cdelt;
  step[1]=1.0;  
  fmin=1e12;
  fmax=-1e12;

// 
//  We correct for the new dispersion
// 
    out_array = (float *)malloc((nmax*image.ny)*sizeof(float)); 
    spec = (float *)malloc((image.nx)*sizeof(float));  	
    wave = (float *)malloc((image.nx)*sizeof(float));  	
    wave_new = (float *)malloc((nmax)*sizeof(float));  	
    out_spec = (float *)malloc((nmax)*sizeof(float));  	


    for (j=0;j<ny;j++) {
	for (i=0;i<nx;i++) {
	    spec[i]=RD_frame(&image,i,j);
	    wave[i]=1.0*i;
//	    printf("%d,%d [%d,%d] %f %f %f\n",i,j,image.nx,image.ny,wave[i],spec[i],a_i_old[i]);
	}	
	spline1(wave,spec,npix[0],a_i_old,out_spec,nmax);
	fmin=1e12;
	fmax=-1e12;
	for (i=0;i<nmax;i++) {
	    wave_new[i]=crval+cdelt*i;
	    out_array[i+j*nmax]=out_spec[i];
	    if (fmin>spec[i]) {
		fmin=spec[i];
	    }
	    if (fmax<spec[i]) {
		fmax=spec[i];
	    }
	}
	
	if (plot==1) {
	    cpgopen("/xs");
	    cpgsfs(1.2);
	    cpgscf(2);             //  Set character font
	    cpgslw(2);             //  Set line width
	    cpgsch(1.2);           //  Set character height
	    cpgenv(crval,crval+cdelt*nmax,fmin,fmax,0,0);
	    cpglab("Wavelength","Counts","");
	    cpgsci(1);
	    cpgline(nmax,wave_new,out_spec);
	    cpgclos();
	    cpgend();
	    printf("Press Enter (A=Automatic, no plot)");
	    scanf("%c",&command);
	    if (command=='A') {
		plot=0;
	    }
	}    
    }

   close_frame(&image);

   printf("Writting the %s file\n",out_file);
   npix[0]=nmax;
   create_frame(&disp_cor,out_file,npix,start,step,FLOAT,"EXTRACTED",NULL);
   for (i=0;i<nmax;i++) {
       for (j=0;j<npix[1];j++) {
	   WR_frame(&disp_cor,i,j,out_array[i+j*nmax]);
       }
   }
   close_frame(&disp_cor);    


   return(0);
}

/*







print "Writting the out_file\n";
system("rm out_file");
write_rss(out_file,n_cut,ny,crval,cdelt,\out_array);
print "DONE\n";

exit;

*/
