/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! COPYRIGHT    (c)  2005 CAHA, Spain
! IDENT        extract_aper.c
! LANGUAGE     C
! AUTHOR       S.F.Sanchez
! KEYWORDS     
! PURPOSE      C version of extract_aper.c
! COMMENT      No GROUP information included. No header data properly copied
! VERSION      0.1  08.08.05 : Creation, SF.
------------------------------------------------------------------------------*/

#include <IFU_io.h>

#include "stats.h"
#include <stdlib.h>

#include "Euro3D.h";

#define NB_SPEC 256
#define NPIX 1024

#include <gl_lsq.h> 

#include <cpgplot.h> // PGPLOT


main(int argc, char *ARGV[])
{

  
    IMAGE2D image,trace,output;
    
    float *array,*tmp_array;
    char infile[80],trace_file[80],out_file[80];
    int spec_axis,i,k,j_min,j_max,j;
    float q;
    float y_shift,a,in_array,w;
    float peak_y_max_new,range,flux,sum_w;
    float peak_y_max_0,peak_y_max_1;
    float flux_near;
    float flux0,flux1;
    float *flux_array;
    float flux_old;


    char **argval, **arglabel;
    long npix[2];
    double start[2];
    double step[2];
    char tmp_char[80];
    float aperture;
    int J_max;
    float FWHM;
    int plot;
    float NORM;
    float A;
    float G,sum;
    int kk;
    int kkk;
    float *y_mod;

    float cut_sum;
    float *cut;
    float *cut_new;
    float *noise_new;
    float *xcut;
    float min,max,xmin,xmax;
    char command;
    
    float C[4],s_a[4],d_a[4];
    float chisq,chisq_lim;
    int ia[4];
    float y_tmp;
    float *ci,*si,*ai;

    float NY;
    int nplot;

    if (argc<7) {
	printf("USE: extract_gauss_multi RAW.fits Spectral_axis[0/1] TRACE.fits OUTPUT.fits WIDTH PLOT [SHIFT]\n");
	return(0);
    }
     set_user_dataformat();
//    init_session(ARGV,argc,&arglabel,&argval);

    strcpy(infile,ARGV[1]);
    spec_axis=atoi(ARGV[2]);
    strcpy(trace_file,ARGV[3]);
//    aperture=atof(ARGV[4]);
    strcpy(out_file,ARGV[4]);
    FWHM=atof(ARGV[5]);
    plot=atoi(ARGV[6]);
    
    A=0.5/pow((fabs(FWHM)/2.345),2);
    NORM=sqrt(3.1416/A);
    nplot=5;

    y_shift=0;
    if (argc==8) {
	y_shift=atof(ARGV[7]);
    }

    printf("Reading file infile '%s'",infile);
    open_frame(&image,infile,"I");
    printf("DONE\n");
    printf("Reading file trace_file '%s'",trace_file);
    open_frame(&trace,trace_file,"I");
    printf("DONE\n");
    printf("Creating the output file '%s'",out_file);

    if (spec_axis==0) {
	if (trace.nx!=image.nx) {
	    printf("The X-dimension of the trace file (trace_file), nx_tr\n");
	    printf("does not match that of the original image, nx\n");
	    printf("%d!=%d",trace.nx,image.nx);
	    return(0);
	}    
    } else {
	if (trace.nx!=image.ny) {
	    printf("The Y-dimension of the trace file (trace_file), nx_tr\n");
	    printf("does not match that of the original image, nx\n");
	    printf("%d!=%d",trace.nx,image.ny);
	    return(0);
	}    
    }
    if (spec_axis==0) {
	npix[0]=image.nx;
	npix[1]=trace.ny;
	J_max=image.ny;
    } else {
	npix[0]=image.ny;
	npix[1]=trace.ny;
	J_max=image.nx;
    }
    start[0]=0.0;
    start[1]=0.0;
    step[0]=1.0;
    step[1]=1.0;
    create_frame(&output,out_file,npix,start,step,FLOAT,"EXTRACTED",NULL);
    printf("DONE\n");

    cut = (float *) malloc( (J_max)*sizeof(float));    
    xcut = (float *) malloc( (J_max)*sizeof(float));    
    y_mod = (float *) malloc( (J_max)*sizeof(float));    
    ci = (float *) malloc( (npix[1])*sizeof(float));    
    si = (float *) malloc( (npix[1])*sizeof(float));    
    ai = (float *) malloc( (npix[1])*sizeof(float));    

    aperture=0;
    a=0.5*aperture;
    printf("Extracting...");


    for (i=0;i<trace.nx;i++) {


	if (i==50*nearbyint(i/50)) {
	    printf("%d,%d\n",i,npix[0]);
	}
	min=1e12;
	max=-1e12;
	for (j=0;j<J_max;j++) {
	    if (spec_axis==0) {
		in_array=RD_frame(&image,i,j);
	    } else {
		in_array=RD_frame(&image,j,i);
	    }
	    xcut[j]=1.0*j;
	    cut[j]=in_array;
	    if (in_array>max) {
		max=in_array;
	    }
	    if (in_array<min) {
		min=in_array;
	    }
	}

	for (k=0;k<trace.ny;k++) {
	    ci[k]=RD_frame(&trace,i,k)+y_shift;	
	    si[k]=FWHM/2.345;
	}

	multi_gaussfit(xcut,cut,J_max,ai,npix[1],ci,si);

	for (kkk=0;kkk<npix[1];kkk++) {
	    flux=ai[kkk]*NORM;
	    WR_frame(&output,i,kkk,flux);
	}



	if (plot==1) {

	    for (j=0;j<J_max;j++) {	    
		y_mod[j]=0.0;
		for (kkk=0;kkk<npix[1];kkk++) {
		    C[0]=ai[kkk];
		    C[1]=ci[kkk];
		    C[2]=si[kkk];
		    C[3]=0;
		    gl_fit_gauss(xcut[j],C,&y_tmp);
		    y_mod[j]=y_mod[j]+y_tmp;
		}
	    }
    

	    cpgopen("/xs");
	    cpgask(0); 
	    cpgscf(2);             //  Set character font
	    cpgslw(2);             //  Set line width
	    cpgsch(1.4);           //  Set character height
	    cpgsubp(1,nplot);
	    xmin=xcut[0];
	    xmax=xcut[J_max-1];
	    for (kkk=0;kkk<nplot;kkk++) {
		cpgsch(1.6);
		cpgenv(xmin+((xmax-xmin)/nplot)*kkk,xmin+((xmax-xmin)/nplot)*(kkk+1),min,max,0,0);
		cpglab("Cross-Disp axis","Counts","");
		cpgsci(1);
		cpgsls(2);
		cpgpt(J_max,xcut,cut,3);
		cpgline(J_max,xcut,cut);
		cpgsci(3);
		cpgsls(1);	
		cpgline(J_max,xcut,y_mod);
		cpgsci(1);
//		cpgpt(J_max,xcut,cut,3);
	    }
	    cpgclos();
	    cpgend();

	}

    }

    close_frame(&output);    
    close_frame(&trace);    
    close_frame(&image);    
    printf("DONE\n");

    return(0);	
}


