/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! COPYRIGHT    (c)  2005 CAHA, Spain
! IDENT        imarith.c
! LANGUAGE     C
! AUTHOR       S.F.Sanchez
! KEYWORDS     
! PURPOSE      C version of imarith.pl
! COMMENT      No GROUP information included. No header data properly copied
! VERSION      0.1  08.08.05 : Creation, SF.
------------------------------------------------------------------------------*/

#include <IFU_io.h>

#include "stats.h"
#include <stdlib.h>


#include <stdio.h> //For Standard I/O
#include <ctype.h> //For Type check
#include <string.h> //For String manipulation
#include <math.h> //For Math functions
#include <data_io.h> //For Lyon I/O data

#include <cpgplot.h> // PGPLOT


main(int argc, char *ARGV[])
{

  
    IMAGE2D image1,image2,out_image;
    char infile1[80],infile2[80],outfile[80];
    char operator;

    int i,j;
    float in_val1,in_val2,out_val;
    long npix[2];
//    int npix[2];
    double start[2];
    double step[2];
    float factor;
    int mode=0;
    int nx_min;
    int ny_min;

    if (argc<5) {
	printf("USE: imarith.pl INPUT1.FITS OPERATOR(+,-,/,*) INPUT2.FITS OUTPUT.FITS\n");
	return(0);
    }

    set_user_dataformat();

    strcpy(infile1,ARGV[1]);
    strcpy(&operator,ARGV[2]);
    strcpy(infile2,ARGV[3]);
    strcpy(outfile,ARGV[4]);

    open_frame(&image1,infile1,"I");
    open_frame(&image2,infile2,"I");
    if ((image2.nx!=floor(image2.nx))||(image2.ny!=floor(image2.ny))) {
	factor=atof(infile2);
	nx_min=image1.nx;
	ny_min=image2.ny;
	mode=1;
    } else {
	mode=0;
    }
    if (image1.nx<image2.nx) {
	nx_min=image1.nx;
    } else {
	nx_min=image2.nx;
    }
    if (image1.ny<image2.ny) {
	ny_min=image1.ny;
    } else {
	ny_min=image2.ny;
    }

	
//    npix[0]=image1.nx;
//    npix[1]=image1.ny;
    npix[0]=nx_min;
    npix[1]=ny_min;
    start[0]=0.0;
    start[1]=0.0;
    step[0]=1.0;
    step[1]=1.0;
    
    create_frame(&out_image,outfile,npix,start,step,FLOAT,"EXTRACTED",NULL);
    
    for (i=0;i<nx_min;i++) {
	for (j=0;j<ny_min;j++) {
	    in_val1=RD_frame(&image1,i,j);
	    if (mode==0) {
		in_val2=RD_frame(&image2,i,j); 
	    } else {
		in_val2=factor;
	    }
	    if (operator=='+') {
		out_val=in_val1+in_val2;
	    }
	    if (operator=='-') {
		out_val=in_val1-in_val2;
	    }
	    if (operator=='*') {
		out_val=in_val1*in_val2;
	    }
	    if (operator=='/') {
		if (in_val2!=0) {
		    out_val=in_val1/in_val2;
		} else {
		    out_val=1e12;
		}
	    }
//	    printf("%d,%d %f %c %f = %f\n",i,j,in_val1,operator,in_val2,out_val);
	    WR_frame(&out_image,i,j,out_val);	
	}
    }
    close_frame(&image2);    
    close_frame(&image1);    
    close_frame(&out_image);    



    return(0);	
}
